#lang racket

;;;; 2. cvičenie z predmetu 1-AIN-616 Symbolické programovanie a LISP
;;;;
;;;; Meno a priezvisko:
;;;; Verzia DrRacket: 6.4
;;;; Dátum: 23.2.2016
;;;; WWW: http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-AIN-616-lisp/1516ls/?lang=sk 
;;;; Kontakt: Jan.Komara(at)fmph.uniba.sk 
;;;;
;;;; Úvodná poznámka. Toto cvičenie je venované týmto témam:
;;;; - chvostová rekurzia a iterácia,
;;;; - celočíselná odmocnina (názorný príklad),
;;;; - Cantorova párovacia funkcia a aritmetizácia karteziánskeho súčinu,
;;;; - funkcionálne programovanie: programy ako argumenty.
;;;; Zadanie sa skladá z týchto súborov: 
;;;; - Súbory ex*.rkt obsahujú úlohy, ktoré máte riešiť na tomto cvičení.
;;;;
;;;; Hodnotenie.
;;;; - Počet bodov za úlohy v tomto súbore: 1
;;;; - Počet bodov za prémiove úlohy v tomto súbore: 0
;;;; - Počet bodov za projektové úlohy v tomto súbore: 0 
;;;; Odovzdať do 28.2.2016 (nedeľa) do 12:00.

;; [Lisp]

(require racket/undefined)
(define ... undefined)
(define (query f m n) (for/list ([i (in-range m (+ n 1))]) (list i (f i))))

;; Literatúra.
;; [1] Hal Abelson and Jerry Sussman and Julie Sussman.
;;     Structure and Interpretation of Computer Programs.
;;     MIT Press, second edition, 1996. 

;;; Kapitola. Rekurzívne definície.

;;; Sekcia. Chvostová rekurzia a iterácia.

;; Príklad. Fibonacciho postupnosť.
;;   fib(0) = 0
;;   fib(1) = 1
;;   fib(n+2) = fib(n+1)+fib(n)

(define (fib n)
  (cond [(= n 0) 0]
        [(= n 1) 1]
        [else (+ (fib (- n 1)) (fib (- n 2)))]))

;; Fibonacciho postupnosť ako iteratívny proces:
;;   fib-iter(n,fib(k+1),fib(k)) = fib(n+1+k) 

(define (fib-iter n a b)
  (if (= n 0) a (fib-iter (- n 1) (+ a b) a)))

(define (fast-fib n)
  (if (= n 0) 0 (fib-iter (- n 1) 1 0)))

;; Alternatívna implementácia s lokálnou procedúrou.

(define (fast-fib2 n)
  (define (fib-iter n a b)
    (if (= n 0) a (fib-iter (- n 1) (+ a b) a)))
  (if (= n 0) 0 (fib-iter (- n 1) 1 0)))

;; (query fib 0 10)
;; (query fast-fib 0 10)
;; (query (λ (n) (list (fib n)  (fast-fib n))) 0 10)

;; Úloha. Nájdite iteratívnu implementáciu nasledujúcej funkcie:
;;   f(0) = 0
;;   f(1) = 1
;;   f(2) = 2
;;   f(n+3) = f(n+2)+f(n+1)+f(n)

(define (f n)
  (cond [(= n 0) 0]
        [(= n 1) 1]
        [(= n 2) 2]
        [else (+ (f (- n 1)) (f (- n 2)) (f (- n 3)))]))

(define (fast-f n) ...)

;; (query f 0 10)
;; (query fast-f 0 10)
;; (query (λ (n) (list (f n)  (fast-f n))) 0 10)

;; Úloha. Nájdite iteratívnu implementáciu nasledujúcej funkcie:
;;   g(0) = 0
;;   g(1) = 1
;;   g(n+2) = g(n+1)+g(n)+n
;; Návod. V implementácii využite pomocnú funkciu:
;;   i ≤ n → g-iter(i,n,g(i+1),g(i)) = g(n+1) 

(define (g n)
  (cond [(= n 0) 0]
        [(= n 1) 1]
        [else (+ (g (- n 1)) (g (- n 2)) (- n 2))]))

(define (fast-g n)
  (define (g-iter i n a b)
    ...)
  ...)

;; (query g 0 10)
;; (query fast-g 0 10)
;; (query (λ (n) (list (g n)  (fast-g n))) 0 10)

;; (1 bod)
;; Úloha. Nájdite iteratívnu implementáciu nasledujúcej funkcie:
;;   h(0) = 0
;;   h(1) = 1
;;   h(2) = 2
;;   h(n+3) = h(n+2)+h(n+1)+h(n)+n+1

(define (h n)
  (cond [(= n 0) 0]
        [(= n 1) 1]
        [(= n 2) 2]
        [else (+ (h (- n 1)) (h (- n 2)) (h (- n 3)) (- n 2))]))

(define (fast-h n) ...)

;; (query h 0 10)
;; (query fast-h 0 10)
;; (query (λ (n) (list (h n)  (fast-h n))) 0 10)
