#lang racket

;;;; 2. cvičenie z predmetu 1-AIN-616 Symbolické programovanie a LISP
;;;;
;;;; Meno a priezvisko:
;;;; Verzia DrRacket: 6.4
;;;; Dátum: 23.2.2016
;;;; WWW: http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-AIN-616-lisp/1516ls/?lang=sk 
;;;; Kontakt: Jan.Komara(at)fmph.uniba.sk 
;;;;
;;;; Úvodná poznámka. Toto cvičenie je venované týmto témam:
;;;; - chvostová rekurzia a iterácia,
;;;; - celočíselná odmocnina (názorný príklad),
;;;; - Cantorova párovacia funkcia a aritmetizácia karteziánskeho súčinu,
;;;; - funkcionálne programovanie: programy ako argumenty.
;;;; Zadanie sa skladá z týchto súborov: 
;;;; - Súbory ex*.rkt obsahujú úlohy, ktoré máte riešiť na tomto cvičení.
;;;;
;;;; Hodnotenie.
;;;; - Počet bodov za úlohy v tomto súbore: 1
;;;; - Počet bodov za prémiove úlohy v tomto súbore: 0
;;;; - Počet bodov za projektové úlohy v tomto súbore: 0 
;;;; Odovzdať do 28.2.2016 (nedeľa) do 12:00.

;; [Lisp]

(require racket/undefined)
(define ... undefined)
(define (query f m n) (for/list ([i (in-range m (+ n 1))]) (list i (f i))))

;; Zopakovanie.

(define (square x) (* x x))

;; Literatúra.
;; [1] Hal Abelson and Jerry Sussman and Julie Sussman.
;;     Structure and Interpretation of Computer Programs.
;;     MIT Press, second edition, 1996.

;;; Kapitola. Rekurzívne definície.

;;; Sekcia. Celočíselná odmocnina (názorný príklad).

;; Špecifikácia nad oborom prirodzených čísel.
;;   integer-sqrt(x) = y ↔ y² ≤ x < (y+1)²

;; (query integer-sqrt 0 100)

;; Príklad. Nasledujúci komponent obsahuje primitívne rekurzívnu definíciu
;; celočíselnej odmocniny.

(define (integer-sqrt1 x)
  (if (= x 0)
      0
      (if (> (square (+ (integer-sqrt1 (- x 1)) 1)) x)
          (integer-sqrt1 (- x 1))
          (+ (integer-sqrt1 (- x 1)) 1))))

;; (query integer-sqrt1 0 20)

;; Úloha. Vylepšite predchadzajúci algoritmus s pomocou špeciálnej formy let.

(define (integer-sqrt2 x) ...)

;; (query integer-sqrt2 0 20)

;; Úloha. Implementujte algoritmus pre výpočet celočíselnej odmocniny, ktorý
;; využíva nasledujúcu vlastnosť:
;;   integer-sqrt(x) = min{y | x < (y+1)²}

(define (integer-sqrt3 x) ...)

;; (query integer-sqrt3 0 20)

;; (1 bod)
;; Úloha. Implementujte rýchly algoritmus pre výpočet celočíselnej odmocniny.

(define (integer-sqrt4 x) ...)

;; (query integer-sqrt4 0 100)
